//============================================================================
// Name        : CPU_test.cpp
// Author      : Fritz Sedlazeck
// Version     : 0.00.00.01
// Copyright   : Mine
// Description : Mapping stuff
//============================================================================



#include <limits.h>
#include <assert.h>
#include <iostream>


void program_close(int id);

#include "nextgenmap/nextgenmap.h"

#include "nextgenmap/cuda_sw/functions/cuda_functions.cuh"

using namespace std;


void program_close(int id);


int main(int argc, char** argv) {

	if (argc== 5|| (argc==7 && strcmp(argv[2], "-p") == 0) ) {
		string parameter_file(argv[1]);
		Parameters parameters;


		cout << "reading parameters" << endl;
		parameters = readParameters_All(parameter_file); //reading parameter
		vector<string> scaffold_file;
		vector<string> reads_file;
		vector<string> out_file;
		vector<string> pair_reads_file;


		if (argc ==7) {
			if (strcmp(argv[2], "-f") == 0) { //short cut for files
				scaffold_file = parse_files(argv[3]);
				reads_file = parse_files(argv[4]);
				if (strcmp(argv[3], "-p") == 0) { //paired end mode
					pair_reads_file = parse_files(argv[5]);
					out_file = parse_files(argv[6]);
				} else {
					out_file = parse_files(argv[5]);
				}

			}else if (strcmp(argv[2], "-p") == 0) { //paired end mode
				scaffold_file.push_back(argv[3]);
				reads_file.push_back(argv[4]);
				pair_reads_file.push_back(argv[5]);
				out_file.push_back(argv[6]);
			} else {
				cout << "invalid input! See the documentation or call the program ./NextGenMap -h" << endl;

				program_close(parameters.GPU_id);
			}

		} else if(argc == 5){//What??
			scaffold_file.push_back(argv[2]);
			reads_file.push_back(argv[3]);
			out_file.push_back(argv[4]);
		}else{
			cout << "invalid input!" << endl;
			program_close(parameters.GPU_id);
		}


		int dev = cudaDevCount();
		//get GPU probaties

		cout << "Your Pc is equipped with: " << dev << " cards. You selected card number: " << parameters.GPU_id << endl;

		if (parameters.GPU_id >= dev) {
			cout << "The GPU ID that you have chosen does not exists." << endl;
			program_close(parameters.GPU_id);
		}

		initCudaParameter(parameters);
		if (parameters.memsize > 399900000) {
			parameters.memsize = 399900000;
		}


		alignment_SW(parameters, scaffold_file, reads_file, out_file, pair_reads_file);


		program_close(parameters.GPU_id);

	} else {
		if(argv[0][0]!='h' || argv[0][1]!='h'){
			cout << "Error: There are " << (5 - argc) << " parameters are missing!" << endl;
			cout << endl;
		}
		cout<<"Single end reads: "<<endl;
		cout << "./NextGenMap parameter_file reference_file read_file output_file" << endl;
		cout<<"Paired end reads: "<<endl;
		cout << "./NextGenMap parameter_file -p reference_file read_file1 read_file2 output_file" << endl;
		cout << endl;
		cout << "parameter_file :Here you can specify your Parameters" << endl;
		cout << "reference_file :A (multi) fasta File containing at least one reference Sequence" << endl;
		cout << "read_file: A fasta or fastq File containing at least one read" << endl;
		cout << "output_file: The file name to where the output should be written" << endl;
		cout <<" for more information please see the documentary or visit our homepage ( http://www.cibiv.at/software/ngm )"<<endl;
		program_close(0);
	}
}

void clean_File(int id) {

	string file = "/tmp/.NextGen";
	for (size_t j = 0; j < id; j++) {
		file += '1';
	}
	remove(file.c_str());
}

void program_close(int id) {
	cout << "Program shuts down." << endl;
	if (id >= 0) {
		clean_File(id);
	}
	exit(0);
}
