/*
 * CUDA_Kernel.cuh
 *
 *  Created on: Nov 12, 2009
 *      Author: fritz
 */

#ifndef CUDA_KERNEL_CUH_
#define CUDA_KERNEL_CUH_

//__device__ __constant__ float param[9 * sizeof(float)];

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ local alignment Mode: +++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.


__global__ void SW_Cuda2(char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,float * param);
__global__ void SW_Cuda_Back2(char * scaffold_gpu, char * reads_gpu, float *matrix_gpu, char *result_gpu, float * parameters, int * pos_gpu, float * matches_gpu,float * param);




//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ BS Mode: ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.

__global__ void SW_CudaBS(char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,float * param);
__global__ void SW_CudaBS_AG(char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,float * param);
__global__ void SW_CudaBS_TC(char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,float * param);
__global__ void SW_CudaBS_Pair(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * paramm,bool *bs_gpu);
__global__ void SW_CudaBS_Back2(char * scaffold_gpu,char * reads_gpu,float *matrix_gpu,char *result_gpu,float * parameters,int * pos_gpu,float * matches_gpu,bool *rev_gpu,float * param);



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ optimal local alignment Mode: +++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.

__global__ void SW_Cuda_optimal(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *score_gpu,int*positions,float * param);


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ global alignment Mode: ++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.
__global__ void Global_Cuda2(char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,float * param);
__global__ void Global_Cuda_Back2(char * scaffold_gpu, char * reads_gpu, float *matrix_gpu, char *result_gpu, float * parameters, int * pos_gpu, float * matches_gpu,float * param);



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ local and global alignment Mode: ++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.
__global__ void Score_Calc_Double (char * scaffold_gpu, char *reads_gpu, float *matrix_gpu, float *results_gpu,int * param,float * scores);

#endif /* CUDA_KERNEL_CUH_ */
