/*
 * versions_SW_gpu.cpp
 *
 *  Created on: Nov 11, 2009
 *      Author: fritz
 */
#include "nextgenmap.h"

#include "parser/reference_parser.h"
#include "printer/printer.h"
#include "cuda_sw/cuda_sw.cuh"
#include "cuda_sw/functions/cuda_functions.cuh"

bool check_position(vector< vector< Match > > candidates,size_t index){
	int position = candidates[0][index].position;
	for(size_t i=0;i<candidates.size();i++){
		if(position!=candidates[i][index].position){ //think of a not that strict way, weighted schemal with result ??
			return false;
		}
	}
	return true;
}

void alignment_SW(Parameters & parameters,vector<string> scaffold_file,
	vector<string> reads_file,vector<string> out_file, vector<string> pair_reads_file){



	for(size_t read = 0;read<reads_file.size();read++){ //loop over input read files
		Reads reads(reads_file[read]);

		Reads pairs;

		if(pair_reads_file.size()>0){
			pairs.set_file_name(pair_reads_file[read]);
		}

		cout<<"Read File: "<<reads_file[read]<<endl;
		if(pair_reads_file.size()>0){
			cout<<"Pair File: "<<pair_reads_file[read]<<endl;
		}
		do{ //loop over one read file
			//the horror of vectors!! :) Think of something better??
			vector< vector< vector< Match > > > candidates; //needed if mix align method is chosen

			reads.clear_reads();
			cout<<"Part: "<<reads.get_number()<<endl;
			reads.inc_numbner();
			//parse reads



			getPartOfReads(reads,parameters);

			if(parameters.mode==4){
				if(candidates.size()==0){
					Match match;
					match.score=-99999999.0f;
					match.position=0;

					vector< Match > temp; //for different (N best) scoring positions;
					temp.push_back(match);

					vector< vector< Match > > temp2;
					for(size_t i=0;i<parameters.match.size()*2;i++){ //for different scoring schemas (local, global) * scoring function
						temp2.push_back(temp);
					}
					for (size_t i=0;i<reads.forward.size();i++){
						candidates.push_back(temp2);
					}
				}else{
					for(size_t i=0;i<candidates.size();i++){
						for(size_t j=0;j<candidates[i].size();j++){
							for(size_t t=0;t<candidates[i][j].size();t++){
								candidates[i][j][t].position=0;
								candidates[i][j][t].score=-99999999.0f;
							}
						}
					}
				}
			}


			size_t runs =1;
			if(parameters.mode==0){
				runs=2;
			}

			if(pair_reads_file.size()>0){ //paired end stuff
				pairs.clear_reads();
				pairs.inc_numbner();

				getPartOfReads_paired(pairs,reads.matches,parameters,reads.forward.size());

				if(pairs.forward.size()<reads.forward.size()){
					for(size_t t=pairs.forward.size(); t<reads.forward.size();t++){
						pairs.forward.push_back("");
						pairs.backward.push_back("");
						pairs.matches.push_back(pairs.matches[0]);
					}
				}

				//is needed to know the required overlap for the scaffold
				if(reads.get_max_length()> pairs.get_max_length()){
					pairs.set_max_length(reads.get_max_length());
				}else if(reads.get_max_length()< pairs.get_max_length()){
					reads.set_max_length(pairs.get_max_length());
				}
			}


			Reference scaffold(parameters.mapsize,(reads.get_max_length()+(parameters.corridor_with))); //init

			bool rev=false;
			for(size_t run =0;run<runs;run++){
				if(rev){
					scaffold.clear_names();
					scaffold.set_id(0);
				}

				//adjust all reads to the maximum size (needed for the GPU)
				if(!rev){
					reads.fit_size(parameters.backward_strain);
					reads.map_keys(true,parameters);//TODO multi thread
				}


				vector< vector< int > > BSlookup;
				if(parameters.mode == 0){
					BSlookup=parseLookup(parameters,rev);
				}

				for(vector<string>::iterator ref = scaffold_file.begin();ref!=scaffold_file.end();ref++){//loop over input reference files
					scaffold.set_filename((*ref));

					cout<<"\t\t"<<"Ref File: "<<scaffold.get_filename()<<endl;
					do{
						// Read in part of the reference:
						getNextScaff(scaffold,parameters);
//
						if(scaffold.sequence[0].size()>0 ){
//							//Hash the reference
							if(parameters.mode!=3){
								scaffold.map_key(parameters); //TODO multi thread
							}


//							//print out information for the reference
							if(scaffold.sequence.size()>1){
								cout<<"\t\t\t"<<"Scaffolds: # "<<scaffold.sequence.size()<< endl;
							}else{
								cout<<"\t\t\t"<<"Scaffold: "<<scaffold.get_name(scaffold.get_ID())<<" length: "<<scaffold.sequence[0].size()<< endl;
							}
							reads.set_direction(true);
							if(scaffold.get_ID()==0 && rev){// && parameters.mode!=3 && !rev){
								//hash each read backward direction
								reads.map_keys(true,parameters);//TODO multi thread
							}

							if(parameters.mode==3){
								Sw_optimal(scaffold,reads,parameters,rev);
							}else if(parameters.mode==4){
								Sw_double(scaffold,reads,parameters,rev,candidates);
							}else if(parameters.mode==0 && parameters.BS_shortcut==2 && rev){

								Sw(scaffold,reads,parameters,rev,BSlookup);
							}else if(parameters.mode==0 && parameters.BS_shortcut==1 && !rev){
								Sw(scaffold,reads,parameters,rev,BSlookup);
							}else if(parameters.BS_shortcut==0){
								Sw(scaffold,reads,parameters,rev,BSlookup);
							}

							if(parameters.backward_strain){
								if(scaffold.get_ID()==0){// && parameters.mode!=3 && !rev){
									//hash each read backward direction
									reads.map_keys(false,parameters);//TODO multi thread
								}
								reads.set_direction(false);

								if(parameters.mode==3){
									Sw_optimal(scaffold,reads,parameters,rev);
								}else if(parameters.mode==4){
									Sw_double(scaffold,reads,parameters,rev,candidates);
								}else if(parameters.mode==0 && parameters.BS_shortcut==2 && !rev){

									Sw(scaffold,reads,parameters,rev,BSlookup);
								}else if(parameters.mode==0 && parameters.BS_shortcut==1 && rev){
									Sw(scaffold,reads,parameters,rev,BSlookup);
								}else if(parameters.BS_shortcut==0){
									Sw(scaffold,reads,parameters,rev,BSlookup);
								}
							}

							scaffold.clear_scaff_keys();
						}

					}while(scaffold.sequence[0].size()>0); //end of the loop over the reference file

				}// end of the loop over all reference files

				if(parameters.mode==0){
					rev=true; //Needed for the BS mode!
					BSlookup.clear();
				}

				reads.clear_keys();
			}



			int count=0;
			for(size_t i=0;i<candidates.size();i++){
				reads.matches[i].match.clear();
				for(size_t j=0;j< candidates[i][0].size();j++){
					if(check_position(candidates[i],j)){
						Match temp;
						temp.BS_rev= candidates[i][0][j].BS_rev;
						temp.forward=candidates[i][0][j].forward;
						temp.position=candidates[i][0][j].position;
						temp.scaffID=candidates[i][0][j].scaffID;
						temp.score=candidates[i][0][j].score;
						reads.matches[i].match.push_back(temp);
					}else{
						count++;
					}
				}
			}
			if(parameters.mode==4){
				cout<<"erased reads: "<<count<<endl;
			}

			cout<<'\t'<<"Calc Output"<<endl;
			//Calculate the alignment and the real matching position
			CalcOutput3(scaffold_file,reads,parameters);

			//paired end
			if(pair_reads_file.size()>0){
				cout<<'\t'<<"Calc Pairs"<<endl;
				scaffold.clear_scaff_keys();

				if(parameters.format==0){
					reads.forward.clear();
					reads.backward.clear();
				}


				pairs.fit_size(parameters.backward_strain);
				cout<<'\t'<<"Calc Pairs Score"<<endl;
				//find position
				if(parameters.mode==0){
					CalcPairs_BS(scaffold_file,pairs,parameters,reads);
				}else{
					CalcPairs(scaffold_file,pairs,parameters,reads);
				}
				cout<<'\t'<<"Calc Pairs Output"<<endl;
				pairs.clear_keys();
				CalcOutput3(scaffold_file,pairs,parameters);
			}

			cout<<"\t"<<"printing to file"<<endl;
			//print all mapped reads to files
			if(parameters.format==0){
				printToFile(out_file[read],reads,pairs,parameters,scaffold);
			}else{
				printToFile_sam(out_file[read],reads,pairs,parameters,scaffold);
			}

			if(pair_reads_file.size()>0){
				pairs.increment_stratId();
			}
			reads.increment_stratId();

		} while(reads.forward.size() >= (size_t)parameters.max_reads_per_run); //end of loop over read file
	} //end of loop over all read files


	cout<<"cleaning up memory"<<endl;
	scaffold_file.clear();
	reads_file.clear();
	out_file.clear();
	cout<<"closing the program"<<endl;

}
