/*
 * parameter.cpp
 *
 *  Created on: Oct 28, 2010
 *      Author: philipp_
 */
#include "parameter.h"
#include <fstream>
#include <cstdlib>

#include "helper/helpers.h"

using std::ifstream;
using std::cout;
using std::endl;

Parameters readParameters(string parameter_file) {


	size_t buffer_size = 300;

	char * buffer = new char[buffer_size];

	Parameters container;
	int temp=0;

	ifstream myfile(parameter_file.c_str());

	if (!myfile.good() || myfile.fail()) {
		cout << "There is a problem with the file: " << parameter_file << endl;
		program_close(-1);

	}

	//word size
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if(temp==0 && !isdigit(buffer[0])){
		cout << "Your word size value is invalid. Please correct that." << endl;
		exit(0);
	}
	if (temp<1 || temp> 13) {
		cout << "Your word size value is invalid. Please correct that." << endl;
		cout << "The current version supports values from 2 to 12." << endl;
		exit(0);
	}else{
		container.wordsize=temp;
	}


	//match penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.match.push_back(atof(&buffer[0]));
	if ((container.match[0]==0 && !isdigit(buffer[0])) || container.match[0]<0) {
		cout << "Your match value is set to a negative value. Please correct that." << endl;
		exit(0);
	}
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.match.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}
	//Mismatch penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.mismatch.push_back(atof(&buffer[0]));
	if ((container.mismatch[0]==0 && !isdigit(buffer[0])) ||container.mismatch[0]>0) {
		cout << "Your mismatch value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.mismatch.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}
	//gaps penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_read.push_back(atof(&buffer[0]));
	if ((container.gap_read[0]==0 && !isdigit(buffer[0]))||container.gap_read[0]>0) {
		cout << "Your gap_read value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.gap_read.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}

	//gaps penalty2
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_scaffold.push_back(atof(&buffer[0]));
	if ((container.gap_scaffold[0]==0 && !isdigit(buffer[0])) ||container.gap_scaffold[0]>0) {
		cout << "Your gap_scaffold value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.gap_scaffold.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}

	//Threshold for N's
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
	container.N_allowed = 100;//atoi(&buffer[0]);

	//Threshold for expanding
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0]))|| (temp<0 || temp>20) ) {
		cout << "Your corridor_with value is invalid. Please correct that." << endl;
		cout << "Larger corridor values then 20 will be supported by the next release." << endl;
		exit(0);
	}else{
		container.corridor_with =temp;
	}
	//N best hits
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
	container.X_best_hits = 1;//atoi(&buffer[0]);
//	if (container.X_best_hits < 0) {
//		cout << "Error wrong parameter for # best hits" << endl;
//		exit(0);
//	}
	//score threshold
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.score_treshold = atof(&buffer[0]);

	//max size of scaffold per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0])) ||temp<0){
		cout << "Your max_scaffold_size value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.max_scaffold_size=temp;
	}
	//number of reads per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0])) ||temp<0){
		cout << "Your max_reads_per_run value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.max_reads_per_run =temp;
	}
	//parameters[12] == step size;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0])) ||temp<1){
		cout << "Your step_size value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.step_size=temp;
	}
	//parameters[13] == Alignment mode; 0== BS- local alignment, 1== local alignment, 2== global alginment;
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//	container.mode = atoi(&buffer[0]);
	container.mode =1;

	//parameters[14] == T-T match
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//
//	container.T_match.push_back(atof(&buffer[0]));
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.T_match.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}
	container.T_match.push_back(0);
	//parameters[15] == T-C mismatch
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//
//	container.T_mismatch.push_back(atof(&buffer[0]));
//	for (size_t i = 0; i < buffer_size; i++) {
//		if (buffer[i] == ',') {
//			container.T_mismatch.push_back(atof(&buffer[i + 1]));
//		} else if (buffer[i] == '\n') {
//			break;
//		}
//	}container.T_mismatch.push_back(atof(&buffer[0]));
	container.T_mismatch.push_back(0);
	//parameters[16] == Type
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//	container.gapped_alignment = (atoi(&buffer[0]) == 1);
	//parameters[17] == identity
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.identity_treshold = atof(&buffer[0]);
	if ((container.identity_treshold==0 && !isdigit(buffer[0])) ||container.identity_treshold<0){
		cout << "Your identity_treshold value is invalid. Please correct that." << endl;
		exit(0);
	}
	//parameters[18] == seedword hits needed
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.seedword_hits = atoi(&buffer[0]);
	if ((container.seedword_hits==0 && !isdigit(buffer[0])) ||container.seedword_hits<=0){
		cout << "Your seedword_hits value is invalid. Please correct that." << endl;
		exit(0);
	}
	//parameters[19] == GPU used to Calc 0-3
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.GPU_id = atoi(&buffer[0]);
	if ((container.GPU_id ==0 && !isdigit(buffer[0]))||container.GPU_id<0){
		cout << "Your GPU_id value is invalid. Please correct that to a positive number." << endl;
		exit(0);
	}
	//parameters[20]: 1== just forward, else also backward
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.backward_strain = (atoi(&buffer[0]) != 1);

	//parameters[21]: 1== just one hit per read is reported independend of equal scoring positions
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//	container.equal_scoring = bool(atoi(&buffer[0]) != 1);
//	container.equal_scoring =true;

//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//
//	if (container.mode == 0) {
//		cout << "BS mode" << endl;
//		//parameters[22]: 1== just +FW and -RC (complement) is calculated.
//
//		container.BS_shortcut = atoi(&buffer[0]);
//	} else {
//		container.BS_shortcut = 0;
//	}
	container.BS_shortcut = 0;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.max_equal_scoring = atoi(&buffer[0]);
//
	if ((container.max_equal_scoring ==0 && !isdigit(buffer[0])) ||container.max_equal_scoring<1){
		cout << "Your max_equal_scoring value is invalid. Please correct that to a positive number." << endl;
		exit(0);
	}
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.format = atoi(&buffer[0]);

	if((container.format==0 && !isdigit(buffer[0])) ||container.format >1 || container.format<0){
		cout<<"This format is currently not supported. Program will fall back to the standard format"<<endl;
		container.format=0;
	}

//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//	for(size_t i=0;i<buffer_size && buffer[i]!='\0' && buffer[i]!='\n';i++){
//		container.TCLook+=buffer[i];
//	}
//
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
//	for(size_t i=0;i<buffer_size&& buffer[i]!='\0' && buffer[i]!='\n';i++){
//		container.AGLook+=buffer[i];
//	}

//	if (container.mode == 0) {
//		cout << "Smith Waterman approach for BS mapping is chosen" << endl;
//		if(container.wordsize!=12){
//			cout<<"The current version can just cope with wordsizes of lenght 12. The wordsize is now set to this paramert."<<endl;
//			container.wordsize=12;
//		}
//	} else if (container.mode == 1) {
//		cout << "Smith Waterman approach is chosen" << endl;
//	} else if (container.mode == 2) {
//		cout << "Global alignment approach is chosen" << endl;
//	} else if (container.mode == 3) {
//		cout << "Optimal alignment is chosen, this is currently not available" << endl;
//		exit(0);
//	} else if (container.mode == 4) {
//		cout << "Mixed alignment is chosen" << endl;
//	}
//	if (!container.gapped_alignment) {
//		cout << "Match Mismatch approach is chosen" << endl;
//		cout << "This is currently not available" << endl;
//		program_close(container.GPU_id);
//	}

	delete[] buffer;
	myfile.close();
	return container;
}




Parameters readParameters_All(string parameter_file) {


	size_t buffer_size = 300;

	char * buffer = new char[buffer_size];

	Parameters container;
	int temp=0;

	ifstream myfile(parameter_file.c_str());

	if (!myfile.good() || myfile.fail()) {
		cout << "There is a problem with the file: " << parameter_file << endl;
		program_close(-1);

	}

	//Threshold for N's
//	myfile.getline(buffer, buffer_size);
//	myfile.getline(buffer, buffer_size);
	container.N_allowed = 100;//atoi(&buffer[0]);

	//word size
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if(temp==0 && !isdigit(buffer[0])){
		cout << "Your word size value is invalid. Please correct that." << endl;
		exit(0);
	}
	if (temp<1 || temp> 13) {
		cout << "Your word size value is invalid. Please correct that." << endl;
		cout << "The current version supports values from 2 to 12." << endl;
		exit(0);
	}else{
		container.wordsize=temp;
	}


	//match penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.match.push_back(atof(&buffer[0]));
	if ((container.match[0]==0 && !isdigit(buffer[0])) || container.match[0]<0) {
		cout << "Your match value is set to a negative value. Please correct that." << endl;
		exit(0);
	}
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.match.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}
	//Mismatch penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.mismatch.push_back(atof(&buffer[0]));
	if ((container.mismatch[0]==0 && !isdigit(buffer[0])) ||container.mismatch[0]>0) {
		cout << "Your mismatch value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.mismatch.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}
	//gaps penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_read.push_back(atof(&buffer[0]));
	if ((container.gap_read[0]==0 && !isdigit(buffer[0]))||container.gap_read[0]>0) {
		cout << "Your gap_read value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.gap_read.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//gaps penalty2
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_scaffold.push_back(atof(&buffer[0]));
	if ((container.gap_scaffold[0]==0 && !isdigit(buffer[0])) ||container.gap_scaffold[0]>0) {
		cout << "Your gap_scaffold value is set to a positive value. Please correct that." << endl;
		exit(0);
	}
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.gap_scaffold.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//Threshold for expanding
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0]))|| (temp<0 || temp>20) ) {
		cout << "Your corridor_with value is invalid. Please correct that." << endl;
		cout << "Larger corridor values then 20 will be supported by the next release." << endl;
		exit(0);
	}else{
		container.corridor_with =temp;
	}
	//N best hits
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.X_best_hits = atoi(&buffer[0]);
	if ((container.X_best_hits<=0 && !isdigit(buffer[0]))) {
		cout << "Your N best hits value is invalid. Please correct that." << endl;
		cout << "Larger corridor values then 20 will be supported by the next release." << endl;
		exit(0);
	}


	//score threshold
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.score_treshold = atof(&buffer[0]);

	//max size of scaffold per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0])) ||temp<0){
		cout << "Your max_scaffold_size value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.max_scaffold_size=temp;
	}


	//number of reads per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);
	if ((temp==0 && !isdigit(buffer[0])) ||temp<0){
		cout << "Your max_reads_per_run value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.max_reads_per_run =temp;
	}

	//parameters[12] == step size;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	temp= atoi(&buffer[0]);

	if ((temp==0 && !isdigit(buffer[0])) ||temp<1){
		cout << "Your step_size value is invalid. Please correct that." << endl;
		exit(0);
	}else{
		container.step_size=temp;
	}
//	parameters[13] == Alignment mode; 0== BS- local alignment, 1== local alignment, 2== global alginment;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.mode = atoi(&buffer[0]);
	if (((container.mode<0 || container.mode> 5) && !isdigit(buffer[0])) ||temp<0){
		cout << "Your max_scaffold_size value is invalid. Please correct that." << endl;
		exit(0);
	}

	//parameters[14] == T-T match
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.T_match.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.T_match.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//parameters[15] == T-C mismatch
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.T_mismatch.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.T_mismatch.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//parameters[17] == identity
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.identity_treshold = atof(&buffer[0]);
	if ((container.identity_treshold==0 && !isdigit(buffer[0])) ||container.identity_treshold<0){
		cout << "Your identity_treshold value is invalid. Please correct that." << endl;
		exit(0);
	}

	//parameters[18] == seedword hits needed
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.seedword_hits = atoi(&buffer[0]);

	if ((container.seedword_hits==0 && !isdigit(buffer[0])) ||container.seedword_hits<=0){
		cout << "Your seedword_hits value is invalid. Please correct that." << endl;
		exit(0);
	}
	//parameters[19] == GPU used to Calc 0-3
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.GPU_id = atoi(&buffer[0]);
	if ((container.GPU_id ==0 && !isdigit(buffer[0]))||container.GPU_id<0){
		cout << "Your GPU_id value is invalid. Please correct that to a positive number." << endl;
		exit(0);
	}
	//parameters[20]: 1== just forward, else also backward
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.backward_strain = (atoi(&buffer[0]) != 1);

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	if (container.mode == 0) {
		//parameters[22]: 1== just +FW and -RC (complement) is calculated.
		container.BS_shortcut = atoi(&buffer[0]);
	} else {
		container.BS_shortcut = 0;
	}


	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.max_equal_scoring = atoi(&buffer[0]);
//
	if ((container.max_equal_scoring ==0 && !isdigit(buffer[0])) ||container.max_equal_scoring<1){
		cout << "Your max_equal_scoring value is invalid. Please correct that to a positive number." << endl;
		exit(0);
	}
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.format = atoi(&buffer[0]);

	if((container.format==0 && !isdigit(buffer[0])) ||container.format >1 || container.format<0){
		cout<<"This format is currently not supported. Program will fall back to the standard format"<<endl;
		container.format=0;
	}

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	for(size_t i=0;i<buffer_size && buffer[i]!='\0' && buffer[i]!='\n';i++){
		container.TCLook+=buffer[i];
	}

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	for(size_t i=0;i<buffer_size&& buffer[i]!='\0' && buffer[i]!='\n';i++){
		container.AGLook+=buffer[i];
	}

	if (container.mode == 0) {
		cout << "Smith Waterman approach for BS mapping is chosen" << endl;
		if(container.wordsize!=12){
			cout<<"The current version can just cope with wordsizes of lenght 12. The wordsize is now set to this paramert."<<endl;
			container.wordsize=12;
		}
	} else if (container.mode == 1) {
		cout << "Smith Waterman approach is chosen" << endl;
	} else if (container.mode == 2) {
		cout << "Global alignment approach is chosen" << endl;
	} else if (container.mode == 3) {
		cout << "Optimal alignment is chosen, this is currently not available" << endl;
		exit(0);
	} else if (container.mode == 4) {
		cout << "Mixed alignment is chosen" << endl;
	}

	delete[] buffer;
	myfile.close();
	return container;
}

Parameters readParameters2(string parameter_file) {

	size_t buffer_size = 300;

	char * buffer = new char[buffer_size];

	Parameters container;
	ifstream myfile(parameter_file.c_str());

	if (!myfile.good() || myfile.fail()) {
		cout << "There is a problem with the file: " << parameter_file << endl;
		program_close(-1);

	}

	//word size
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.wordsize = atoi(&buffer[0]);
	if (container.wordsize > 13) {
		cout << "Sorry wont work in this version." << endl;
		exit(0);
	}

	//match penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.match.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.match.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}
	//Mismatch penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.mismatch.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.mismatch.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}
	//gaps penalty
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_read.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.gap_read.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//gaps penalty2
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.gap_scaffold.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.gap_scaffold.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//Threshold for N's
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.N_allowed = atoi(&buffer[0]);

	//Threshold for expanding
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.corridor_with = atoi(&buffer[0]);

	//N best hits
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.X_best_hits = atoi(&buffer[0]);
	if (container.X_best_hits < 0) {
		cout << "Error wrong parameter for # best hits" << endl;
		exit(0);
	}
	//score threshold
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.score_treshold = atof(&buffer[0]);
	//max size of scaffold per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.max_scaffold_size = atoi(&buffer[0]);
	//number of reads per run
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.max_reads_per_run = atoi(&buffer[0]);
	//parameters[12] == step size;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.step_size = atoi(&buffer[0]);

	//parameters[13] == Alignment mode; 0== BS- local alignment, 1== local alignment, 2== global alginment;
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.mode = atoi(&buffer[0]);

	//parameters[14] == T-T match
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.T_match.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.T_match.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//parameters[15] == T-C mismatch
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	container.T_mismatch.push_back(atof(&buffer[0]));
	for (size_t i = 0; i < buffer_size; i++) {
		if (buffer[i] == ',') {
			container.T_mismatch.push_back(atof(&buffer[i + 1]));
		} else if (buffer[i] == '\n') {
			break;
		}
	}

	//parameters[16] == Type
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
//	container.gapped_alignment = (atoi(&buffer[0]) == 1);
	//parameters[17] == identity
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.identity_treshold = atof(&buffer[0]);
	//parameters[18] == seedword hits needed
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.seedword_hits = atoi(&buffer[0]);
	//parameters[19] == GPU used to Calc 0-3
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.GPU_id = atoi(&buffer[0]);
	//parameters[20]: 1== just forward, else also backward
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.backward_strain = (atoi(&buffer[0]) != 1);
	//parameters[21]: 1== just one hit per read is reported independend of equal scoring positions
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
//	container.equal_scoring = bool(atoi(&buffer[0]) != 1);

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);

	if (container.mode == 0) {
		cout << "BS mode" << endl;
		//parameters[22]: 1== just +FW and -RC (complement) is calculated.

		container.BS_shortcut = atoi(&buffer[0]);
	} else {
		container.BS_shortcut = 0;
	}
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.max_equal_scoring = atoi(&buffer[0]);
//
	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	container.format = atoi(&buffer[0]);

	if(container.format >1){
		cout<<"this format is currently not supported. Program will fall back to the standart format"<<endl;
		container.format=0;
	}

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	for(size_t i=0;i<buffer_size && buffer[i]!='\0' && buffer[i]!='\n';i++){
		container.TCLook+=buffer[i];
	}

	myfile.getline(buffer, buffer_size);
	myfile.getline(buffer, buffer_size);
	for(size_t i=0;i<buffer_size&& buffer[i]!='\0' && buffer[i]!='\n';i++){
		container.AGLook+=buffer[i];
	}

	if (container.mode == 0) {
		cout << "Smith Waterman approach for BS mapping is chosen" << endl;
		if(container.wordsize!=12){
			cout<<"The current version can just cope with wordsizes of lenght 12. The wordsize is now set to this paramert."<<endl;
			container.wordsize=12;
		}
	} else if (container.mode == 1) {
		cout << "Smith Waterman approach is chosen" << endl;
	} else if (container.mode == 2) {
		cout << "Global alignment approach is chosen" << endl;
	} else if (container.mode == 3) {
		cout << "Optimal alignment is chosen, this is currently not available" << endl;
		exit(0);
	} else if (container.mode == 4) {
		cout << "Mixed alignment is chosen" << endl;
	}
//	if (!container.gapped_alignment) {
//		cout << "Match Mismatch approach is chosen" << endl;
//		cout << "This is currently not available" << endl;
//		program_close(container.GPU_id);
//	}

	delete[] buffer;
	myfile.close();
	return container;
}

vector<string> parse_files(string filename) {

	ifstream myfile;
	myfile.open(filename.c_str(), ifstream::in);

	if (!myfile.good() || myfile.fail()) {
		cout << "There is a problem with the file: " << filename << endl;
		program_close(-1);

	}

	int buffer_size = 2000;
	char*buffer = new char[buffer_size];

	myfile.getline(buffer, buffer_size);
	vector<string> files;

	while (!myfile.eof()) {
		int i = 0;
		string file;
		while (i < buffer_size && buffer[i] != '\n' && buffer[i] != '\0' && buffer[i] != ' ') {
			file += buffer[i];
			i++;
		}
		files.push_back(file);
		file.clear();
		myfile.getline(buffer, buffer_size);
	}
	myfile.close();
	return files;
}

int FatsHash2(string str){//, Parameters parameters) {

	int result = 0;

	for (size_t i = 0; i < str.size(); i++) {
		switch (str[i]) {
		case 'A':
			result = result + (0 << (i * 2));
			break;
		case 'C':
			result = result + (1 << (i * 2));
			break;
		case 'G':
			result = result + (2 << (i * 2));
			break;
		case 'T':
			//T in read is == C in scaff!
//			if (parameters.mode == 0) {
//				result = result + (1 << (i * 2));
//			} else {
				result = result + (3 << (i * 2));
//			}
			break;
		default:
			//			str.clear();
			return -1;
		}
	}

	//	str.clear();
	return result;
}

int FatsHash(string str){//, Parameters parameters) {

	int result = 0;

	for (size_t i = 0; i < str.size(); i++) {
		switch (str[i]) {
		case 'A':
			result = result + (0 << (i * 2));
			break;
		case 'C':
			result = result + (1 << (i * 2));
			break;
		case 'G':
//			if (parameters.mode == 0) {
//				result = result + (0 << (i * 2));
//			} else {
				result = result + (2 << (i * 2));
//			}
			break;
		case 'T':
			result = result + (3 << (i * 2));
			break;
		default:
			return -1;
		}
	}
	return result;
}


vector< vector< int> > parseLookup(Parameters parameters,bool ref){
		ifstream myfile;

		if(!ref){
			myfile.open(parameters.TCLook.c_str(), ifstream::in);
		}else{
			myfile.open(parameters.AGLook.c_str(), ifstream::in);
		}

//		if(ref){
//			myfile.open(parameters.AGLook.c_str(), ifstream::in);
//		}else{
//			myfile.open(parameters.TCLook.c_str(), ifstream::in);
//		}

		if (!myfile.good() || myfile.fail()) {
			if(ref){
				cout<<"The program needs access to the lookup file A-G  mismatches"<<endl;
				cout<<" The file you entered is not valid: "<<parameters.AGLook<<endl;
			}else{
				cout<<"The program needs access to the lookup file T-C  mismatches"<<endl;
				cout<<" The file you entered is not valid: "<<parameters.TCLook<<endl;
			}
			exit(0);
		}

		vector< int> temp;
		vector< vector< int> > lookup;
		lookup.assign(parameters.mapsize+1,temp);
		size_t buffer_size=1000000;
		char * line= new char [buffer_size];

		myfile.getline(line,buffer_size);

		while(myfile.good()){
			int val=atoi(&line[0]);

			for(size_t i=0;i<buffer_size && line[i]!='\n' &&line[i]!='\0';i++){
				if(line[i]=='\t' && line[i+1]!='\n' &&line[i+1]!='\0' ){
					lookup[atoi(&line[i+1])].push_back(val);
				}
			}

			myfile.getline(line,buffer_size);
		}
		myfile.close();
		delete [] line;
		return lookup;

	}

