/*
 * parameter.h
 *
 *  Created on: Oct 28, 2010
 *      Author: philipp_
 */

#ifndef PARAMETER_H_
#define PARAMETER_H_

#include <iostream>
#include <vector>

using std::string;
using std::vector;


struct Parameters {
	size_t wordsize;

	vector<float> match;
	vector<float> mismatch;
	vector<float> gap_read;
	vector<float> gap_scaffold;
	vector<float> T_match;
	vector<float> T_mismatch;


	size_t N_allowed;
	size_t corridor_with;
	int X_best_hits;
	float score_treshold;
	float identity_treshold;
	size_t max_scaffold_size;
	size_t max_reads_per_run;
	size_t step_size;
	int mode; //0 == BS-SW, 1== local alignment, 2 == global alignment

	int seedword_hits;
	int GPU_id;
	bool backward_strain;
//	bool equal_scoring;
	int mapsize;
	int mps;
	long memsize;
	int BS_shortcut;
	int max_equal_scoring;

	int format; //0== NextGen Format, 1== SAM Format;

	string TCLook;
	string AGLook;
};
vector< vector< int> > parseLookup(Parameters parameters,bool ref);
Parameters readParameters_All(string parameter_file);
Parameters readParameters(string parameter_file);
vector<string> parse_files(string filename);
int FatsHash2(string str);//,Parameters parameters);//FatsHash2(string str, Parameters parameters);
int FatsHash(string str);//, Parameters parameters);

#endif /* PARAMETER_H_ */
