/*
 * print.cpp
 *
 *  Created on: Nov 11, 2009
 *      Author: fritz
 */

#include "printer.h"
#include <algorithm>

bool correct(vector<Match>::iterator match, vector<Match>::iterator match_pair, string matchRef, string pairRef, Parameters parameters) {

	if (strcmp(matchRef.c_str(), pairRef.c_str()) == 0 && (parameters.mode == 2 || (*match_pair).identity > parameters.identity_treshold)) {
		if ((*match).forward) {
			//if first read matched forward second have to be backward
			return (*match_pair).position >= (*match).position;
		} else {
			//if first read matched backward second have to be forward
			return (*match_pair).position <= (*match).position;
		}
	}

	return false;
}

struct sorting3 {
	bool operator ()(pair<int, size_t> a, pair<int, size_t> b) {
		return (a.first < b.first);
	}
} sorting_pos;

struct sorting4 {
	bool operator ()(pair<float, size_t> a, pair<float, size_t> b) {
		return (a.first > b.first);
	}
} sorting_id;

struct sorting5 {
	bool operator ()(Match a, Match b) {
		return (a.identity > b.identity);
	}
} sorting_identi;

vector<int> sort_bla_pos(Matches matches) {
	vector<int> positons;

	if (matches.match.size() == 1) {
		positons.push_back(0);
		return positons;
	}
	vector<pair<int, int> > forward;
	vector<pair<int, int> > back;

	for (size_t i = 0; i < matches.match.size(); i++) {
		if (matches.match[i].forward) {
			forward.push_back(pair<int, size_t> (matches.match[i].position, i));
		} else {
			back.push_back(pair<int, size_t> (matches.match[i].position, i));
		}
	}
	sort(forward.begin(), forward.end(), sorting_pos);
	sort(back.begin(), back.end(), sorting_pos);

	for (size_t i = 0; i < forward.size(); i++) {
		positons.push_back(forward[i].second);
	}
	for (size_t i = 0; i < back.size(); i++) {
		positons.push_back(back[i].second);
	}
	return positons;

}

vector<int> sort_bla_id(Matches &matches) {

	vector<int> positons;

	if (matches.match.size() == 1) {
		positons.push_back(0);
		return positons;
	}

	sort(matches.match.begin(), matches.match.end(), sorting_identi);

	vector<int> deletes;

		//TODO schau dir das kurz mal an:
	for (size_t i = 1; i < matches.match.size(); i++) {
		if (matches.match[i].position == matches.match[i - 1].position) {
			deletes.push_back(i);
		}
	}
	for (vector<int>::reverse_iterator i = deletes.rbegin(); i != deletes.rend(); i++) {
		matches.match.erase(matches.match.begin() + (*i));
	}

	deletes.clear();

	for (size_t i = 0; i < matches.match.size(); i++) {
		if (matches.match[0].identity < matches.match[i].identity) {
			matches.match.erase(matches.match.begin() + i, matches.match.end());
			break;
		}
	}

	vector<pair<float, size_t> > forward;
	vector<pair<float, size_t> > back;

	for (size_t i = 0; i < matches.match.size(); i++) {
		if (matches.match[i].forward) {
			forward.push_back(pair<float, int> (matches.match[i].identity, i));
		} else {
			back.push_back(pair<float, int> (matches.match[i].identity, i));
		}
	}

	sort(forward.begin(), forward.end(), sorting_id);
	sort(back.begin(), back.end(), sorting_id);

	for (size_t i = 0; i < forward.size(); i++) {
		positons.push_back(forward[i].second);
	}

	for (size_t i = 0; i < back.size(); i++) {
		positons.push_back(back[i].second);
	}
	return positons;

}

//out_file,reads,parameters/
void printToFile(string filename, Reads & reads, Reads & pairs, Parameters parameters, Reference scaff) {

	FILE *file;
	if (reads.get_number() == 1) {
		file = fopen(filename.c_str(), "w");
	} else {
		file = fopen(filename.c_str(), "a");
	}
	if(file==NULL){
		cout<<"Error in printing: The file or path that you set is not valid. It can be that there is no disc space available."<<endl;
		exit(0);
	}

	FILE *notmapped = 0;
	FILE *notmapped_pair = 0;

	if (reads.get_number() == 1) {
		notmapped = fopen(string(filename + "_notmapped.fa").c_str(), "w");
		if (pairs.forward.size() > 0) {
			notmapped_pair = fopen(string(filename + "_notmapped_pair.fa").c_str(), "w");
		}
	} else {
		notmapped = fopen(string(filename + "_notmapped.fa").c_str(), "a");
		if (pairs.forward.size() > 0) {
			notmapped_pair = fopen(string(filename + "_notmapped_pair.fa").c_str(), "a");
		}
	}

	int allowed = 0;
	int paired_allowed = 0;
	size_t id = 0;

	for (vector<Matches>::iterator i = reads.matches.begin(); i != reads.matches.end(); i++) {

		if (parameters.mode == 2 || (*i).match[0].score > parameters.score_treshold) {
			allowed++;
//			cout<<"check"<<endl;
			if (( pairs.matches.size()>id&& pairs.matches[id].match.size()>0) && (parameters.mode == 2 || (pairs.matches[id].match[0].identity >= parameters.identity_treshold && pairs.matches[id].match[0].score >= parameters.score_treshold))) {
				paired_allowed++;
			}
		}
		int border = 1;


		vector<int> positions;

		if ((int) (*i).match.size() > parameters.X_best_hits) {
			positions = sort_bla_id((*i));
		} else {
			for (size_t j = 0; j < (*i).match.size(); j++) {
				positions.push_back(j);
			}
		}

		if (parameters.X_best_hits > 1 || parameters.max_equal_scoring>1 ) {
			border = (*i).match.size();
		}
		if (positions.size() != (*i).match.size()) {
			cout << "Printer: position.size()!=match.size()" << endl;
			exit(0);
		}
		for (int t = 0; t < border; t++) {
			vector<Match>::iterator match = (*i).match.begin() + positions[t];

			if ((parameters.mode == 2 && (*match).identity >= parameters.identity_treshold) || ((*match).identity >= parameters.identity_treshold && (*match).score >= parameters.score_treshold)) {
				fprintf(file, "Seq ID: ");
				fprintf(file, "%i", (int)id + reads.get_startID());

				fprintf(file, " Match ID: ");
				fprintf(file, "%i", t);

				fprintf(file, " Name: ");
				fprintf(file, (*i).read_name.c_str());

				if ((*match).forward) {
					fprintf(file, " forward ");
				} else {
					fprintf(file, " backward ");

				}
				fprintf(file, " matches at: ");
				fprintf(file, "%i", (*match).position);

				fprintf(file, " at scaffold: ");
				fprintf(file, "%s", scaff.get_name((*match).scaffID).c_str());

				fprintf(file, " Score: ");
				fprintf(file, "%i", (int) (*match).score);
				fprintf(file, "%c", '\n');
				//end of first line
				fprintf(file, "times: "); //TODO think about if N>1
				fprintf(file, "%i", (int) (*i).match.size());
				fprintf(file, "%c", ' ');
				fprintf(file, "identity: ");
				fprintf(file, "%f", (*match).identity);

				fprintf(file, "%c", ' ');

				if ((*match).forward && !(*match).BS_rev) {
					fprintf(file, "%s", "++"); //forward ignoring C-T
				} else if (!(*match).forward && !(*match).BS_rev) {
					fprintf(file, "%s", "+-"); //reverse comp ignoring C-T
				} else if ((*match).forward && (*match).BS_rev) {
					fprintf(file, "%s", "--"); //complement ignoring G-A
				} else if (!(*match).forward && (*match).BS_rev) {
					fprintf(file, "%s", "-+"); //reverse complement ignoring G-A
				}

				fprintf(file, "%c", ' ');
				fprintf(file, " Q_start: ");
				fprintf(file, "%i", (*match).Q_start);
				fprintf(file, "%c", ' ');
				fprintf(file, " Q_end: ");
				fprintf(file, "%i", (*match).Q_end);
				fprintf(file, "%c", '\n');

				//end of second line
				fprintf(file, "%s", (*match).scaff.c_str());
				fprintf(file, "%c", '\n');
				fprintf(file, "%s", (*match).read.c_str());

				(*match).read.clear();
				(*match).scaff.clear();

				fprintf(file, "%c", '\n');
				if (pairs.matches.size() > 0 && pairs.matches[id].match.size()>0 && strcmp(pairs.matches[id].read_name.c_str(),"FAKE")!=0) {
					if ((parameters.mode == 2 && pairs.matches[id].match[0].identity >= parameters.identity_treshold) || (pairs.matches[id].match[0].identity >= parameters.identity_treshold && pairs.matches[id].match[0].score >= parameters.score_treshold)) {

						int z=0;
						for (vector<Match>::iterator match_pair = pairs.matches[id].match.begin(); match_pair != pairs.matches[id].match.end(); match_pair++) {
							if (correct(match, match_pair, scaff.get_name((*match).scaffID), scaff.get_name((*match_pair).scaffID), parameters)) {
								fprintf(file, "Seq ID: ");
								fprintf(file, "%i", (int)id + reads.get_startID());
								fprintf(file, " Match ID: ");
								fprintf(file, "%i", z);
								z++;
								fprintf(file, " Name: ");
								fprintf(file, pairs.matches[id].read_name.c_str());
								if ((*match_pair).forward) {
									fprintf(file, " forward ");
								} else {
									fprintf(file, " backward ");
								}
								fprintf(file, " matches at: ");
								fprintf(file, "%i", (*match_pair).position);

								fprintf(file, " at scaffold: ");
								fprintf(file, "%s", scaff.get_name((*match_pair).scaffID).c_str());

								fprintf(file, " Score: ");
								fprintf(file, "%i", (int) (*match_pair).score);
								fprintf(file, "%c", '\n');

								fprintf(file, "times: ");
								fprintf(file, "%i", (int) pairs.matches[id].match.size());
								fprintf(file, "%c", ' ');
								fprintf(file, "identity: ");
								fprintf(file, "%f", (*match_pair).identity);

								fprintf(file, "%c", ' ');

								if ((*match_pair).forward && !(*match_pair).BS_rev) {
									fprintf(file, "%s", "++"); //forward ignoring C-T
								} else if (!(*match_pair).forward && !(*match_pair).BS_rev) {
									fprintf(file, "%s", "+-"); //reverse comp ignoring G-A
								} else if ((*match_pair).forward && (*match_pair).BS_rev) {
									fprintf(file, "%s", "--"); //complement ignoring G-A
								} else if (!(*match_pair).forward && (*match_pair).BS_rev) {
									fprintf(file, "%s", "-+"); //reverse complement ignoring C-T
								}

								fprintf(file, "%c", ' ');
								fprintf(file, " Q_start: ");
								fprintf(file, "%i", (*match_pair).Q_start);
								fprintf(file, "%c", ' ');
								fprintf(file, " Q_end: ");
								fprintf(file, "%i", (*match_pair).Q_end);
								fprintf(file, "%c", '\n');

								//end of second line
								fprintf(file, "%s", (*match_pair).scaff.c_str());
								fprintf(file, "%c", '\n');
								fprintf(file, "%s", (*match_pair).read.c_str());
								fprintf(file, "%c", '\n');

							}//end if correct
						}//end for

					} else { //end check for identity
						if (pairs.forward.size() > 0) {
							if(strcmp(pairs.matches[id].read_name.c_str(),"FAKE")!=0){
								fprintf(notmapped_pair, "%c", '>');
								fprintf(notmapped_pair, "%s", pairs.matches[id].read_name.c_str());
								fprintf(notmapped_pair, "%c", '\n');
								fprintf(notmapped_pair, "%s", pairs.forward[id].c_str());
								fprintf(notmapped_pair, "%c", '\n');
							}
						}
					}
				}

			} else {
				//print out those reads that failed:
				if (t == 0) {
					fprintf(notmapped, "%c", '>');
					fprintf(notmapped, "%s", (*i).read_name.c_str());
					fprintf(notmapped, "%c", '\n');
					fprintf(notmapped, "%s", reads.forward[id].c_str());
					fprintf(notmapped, "%c", '\n');
					reads.matches[id].read_name.clear();
					reads.matches[id].match[0].read.clear();
					reads.matches[id].match[0].scaff.clear();
				}
			}
		}



		id++;
		(*i).match.clear();
		(*i).read_name.clear();

	}

	fclose(notmapped);
	fclose(file);
	cout << "\t" << "aligned: " << allowed << " out of: " << reads.matches.size() << endl;

	if (pairs.forward.size()) {
		cout << "\t" << "paired aligned: " << paired_allowed << " out of: " << pairs.matches.size() << endl;
	}
	pairs.matches.clear();
	reads.matches.clear();
}

void calcMD(FILE *& file,Match read){
	size_t i=0;

	int match=0;
	int del=0;
	while(i<read.read.size()){
		if(read.read[i]==read.scaff[i]){
			del=0;
			match++;
		}else if ( read.read[i]=='-'){
			if(match>0){
				fprintf(file,"%i",match);
				match=0;
			}
			if(del==0){
				fprintf(file,"%c",'^');
			}
			fprintf(file,"%c",read.scaff[i]);
			del++;

//		}else if(read.scaff[i]=='-'){
//			if(match>0){
//				fprintf(file,"%i",match);
//				match=0;
//			}
//			if(del==0){
//				fprintf(file,"%c",'^');
//			}
//			fprintf(file,"%c",read.read[i]);
//			del++;
		}else if (read.scaff[i]!='-'){
			if(del>0){
				fprintf(file,"%i",0);
			}
			del=0;
			if(match>0){
				fprintf(file,"%i",match);
				match=0;
			}

			fprintf(file,"%c",read.scaff[i]);
		}

		i++;
	}
	if(match>0){
		fprintf(file,"%i",match);
	}

}




void calcpattern(FILE *& file2,Match read){

//	string temp_read;
//	string temp_scaff;

//	string search;
	if(read.Q_start>0){
		fprintf(file2,"%i",read.Q_start);fprintf(file2,"%c",'S');
	}
	int match=0;
	bool flag=false;

	for(size_t i=0;i<read.read.size();i++){
		if(read.read[i]=='-'){

			fprintf(file2,"%i",match);fprintf(file2,"%c",'M');
			match=0;
			size_t t=0;
			while(i+1<read.read.size() && read.read[i]=='-'){
				i++;
				t++;
			}
			if(i+1==read.read.size() && t==0){
				i++;
			}
			i=i-1;
			if(i+1==read.read.size() && t==0){
				i++;
				read.Q_end++;
			}
			if(t!=0){
				fprintf(file2,"%i",(int)t);
				fprintf(file2,"%c",'D');
			}

		}else if(read.scaff[i]=='-'){

			flag=true;
			fprintf(file2,"%i",match);fprintf(file2,"%c",'M');
			match=0;
			size_t t=0;
			while(i+1<read.read.size() && read.scaff[i]=='-'){
				i++;
				t++;
			}
			if(i+1==read.read.size() && t==0){
				i++;
				read.Q_end++;
			}
			i=i-1;

			if(t!=0){
				fprintf(file2,"%i",(int)t);
				fprintf(file2,"%c",'I');
			}
		}else{
			match++;
		}
	}

	fprintf(file2,"%i",match);fprintf(file2,"%c",'M');


	if(read.Q_end>0){
		fprintf(file2,"%i",(int)read.Q_end);
		fprintf(file2,"%c",'S'); //this is wrong
	}
}


void getNextScaff_SAM(string filename, FILE * & file){

	ifstream myfile (filename.c_str());
	char buffer= myfile.get();

	int lenght=0;
	string name;
	while (myfile.good()) {
		if (buffer == '>') {
			if(name.size()!=0){
				fprintf(file,"%s","@SQ\tSN:");fprintf(file,"%s",name.c_str());
				fprintf(file,"%s","\tLN:");fprintf(file,"%i",lenght);
				fprintf(file,"%c",'\n');

				name.clear();
				lenght=0;
			}

			buffer = myfile.get();
			while (myfile.good() && buffer != '\0' && buffer != ' ' && buffer != '\n') { //reading in the name
				name += buffer;
				buffer = myfile.get();
			}
			while (buffer != '\n' && buffer != '\0') { //run until the end of the line
				buffer = myfile.get();
			}
		}else if (buffer != ' ' && buffer != '\0' && buffer != '\n') {
			while (myfile.good() && buffer != '\0' && buffer != '\n') {
				lenght++;
				buffer = myfile.get();
			}
		}
		buffer = myfile.get();
	}
	if(name.size()!=0){
		fprintf(file,"%s","@SQ\tSN:");fprintf(file,"%s",name.c_str());
		fprintf(file,"%s","\tLN:");fprintf(file,"%i",lenght);
		fprintf(file,"%c",'\n');

		name.clear();
		lenght=0;
	}
	myfile.close();
}



void printToFile_sam(string filename, Reads & reads, Reads & pairs, Parameters parameters, Reference scaff) {

	FILE *file;
	if (reads.get_number() == 1) {
		file = fopen(filename.c_str(), "w");
		//write header:
		getNextScaff_SAM(scaff.get_filename(),file);
	} else {
		file = fopen(filename.c_str(), "a");
	}
	if(file==NULL){
		cout<<"Error in printing: The file or path that you set is not valid. It can be that there is no disc space available."<<endl;
		exit(0);
	}

	int allowed = 0;
	int paired_allowed = 0;
	size_t id = 0;

	for (vector<Matches>::iterator i = reads.matches.begin(); i != reads.matches.end(); i++) {

		if (parameters.mode == 2 || (*i).match[0].score > parameters.score_treshold) {
			allowed++;
//			cout<<"check"<<endl;
			if (( pairs.matches.size()>id&& pairs.matches[id].match.size()>0) && (parameters.mode == 2 || (pairs.matches[id].match[0].identity >= parameters.identity_treshold && pairs.matches[id].match[0].score >= parameters.score_treshold))) {
				paired_allowed++;
			}
		}
		int border = 1;


		vector<int> positions;

		if ((int) (*i).match.size() > parameters.X_best_hits) {
			positions = sort_bla_id((*i));
		} else {
			for (size_t j = 0; j < (*i).match.size(); j++) {
				positions.push_back(j);
			}
		}

		if (parameters.X_best_hits > 1 ||parameters.max_equal_scoring>1 ) {
			border = (*i).match.size();
		}
		if (positions.size() != (*i).match.size()) {
			cout << "Printer: position.size()!=match.size()" << endl;
			exit(0);
		}
		for (int t = 0; t < border; t++) {
			vector<Match>::iterator match = (*i).match.begin() + positions[t];

			fprintf(file,"%s",(*i).read_name.c_str());
			fprintf(file,"%c",'\t');

			bool flag=true;
			if(((*match).identity < parameters.identity_treshold || (*match).score < parameters.score_treshold)){
				fprintf(file,"%s","4\t*\t0\t0\t*\t*\t0\t0");
				flag=false;
			}else{

				if((*match).forward){
					fprintf(file,"%i",0);
				}else{
					fprintf(file,"%i",16);
				}
				fprintf(file,"%c",'\t');
				fprintf(file,"%s",scaff.get_name((*match).scaffID).c_str());
				fprintf(file,"%c",'\t');
				fprintf(file,"%i",(*match).position+1);
				fprintf(file,"%c",'\t');
				fprintf(file,"%i",255);
				fprintf(file,"%c",'\t');

				calcpattern(file,(*match));
				fprintf(file,"%c",'\t');
				fprintf(file,"%c",'*');
				fprintf(file,"%c",'\t');
				fprintf(file,"%s","0\t0");
			}


			fprintf(file,"%c",'\t');
			if((*match).forward){
				for(string::iterator k=reads.forward[id].begin();k!=reads.forward[id].end();k++){
					if((*k)!='#'){
						fprintf(file,"%c",(*k));
					}else{
						break;
					}
				}
			}else{
				for(string::iterator k=reads.backward[id].begin();k!=reads.backward[id].end();k++){
					if((*k)!='#'){
						fprintf(file,"%c",(*k));
					}else{
						break;
					}
				}
			}
			fprintf(file,"%c",'\t');


			if((*i).qualitvals.size()==0){
				fprintf(file,"%c",'*');
			}else{
				fprintf(file,"%s",(*i).qualitvals.c_str());
			}

			if(((*match).identity > parameters.identity_treshold && (*match).score > parameters.score_treshold)){

				fprintf(file,"%c",'\t');
				fprintf(file,"%s","AS:i:");
				if(flag){
					fprintf(file,"%i",(int)(*match).score);
				}else{
					fprintf(file,"%c",'*');
				}
				fprintf(file,"%c",'\t');
				fprintf(file,"%s","MD:Z:");
				calcMD(file,(*match));

			}
			fprintf(file,"%c",'\n');

			if (pairs.matches.size() > 0 && pairs.matches[id].match.size()>0 && strcmp(pairs.matches[id].read_name.c_str(),"FAKE")!=0) {

				for (vector<Match>::iterator match_pair = pairs.matches[id].match.begin(); match_pair != pairs.matches[id].match.end(); match_pair++) {
					if(correct(match, match_pair, scaff.get_name((*match).scaffID), scaff.get_name((*match_pair).scaffID), parameters)){
						fprintf(file,"%s",pairs.matches[id].read_name.c_str());
						fprintf(file,"%c",'\t');
						bool flag=true;

						if( pairs.matches[id].match[0].identity < parameters.identity_treshold || pairs.matches[id].match[0].score < parameters.score_treshold){
							fprintf(file,"%s","4\t*\t0\t0\t*\t*\t0\t0");
							flag=false;
						}else{
							if((*match_pair).forward){
								fprintf(file,"%i",0);
							}else{
								fprintf(file,"%i",16);
							}
							fprintf(file,"%c",'\t');
							fprintf(file,"%s",scaff.get_name((*match_pair).scaffID).c_str());
							fprintf(file,"%c",'\t');
							fprintf(file,"%i",(*match_pair).position+1);
							fprintf(file,"%c",'\t');
							fprintf(file,"%i",255);
							fprintf(file,"%c",'\t');

							calcpattern(file,(*match_pair));
							fprintf(file,"%c",'\t');
							fprintf(file,"%c",'*');
							fprintf(file,"%c",'\t');
							fprintf(file,"%s","0\t0");
						}

						fprintf(file,"%c",'\t');

						if((*match).forward){
							for(string::iterator k=pairs.forward[id].begin();k!=pairs.forward[id].end();k++){
								if((*k)!='#'){
									fprintf(file,"%c",(*k));
								}else{
									break;
								}
							}
						}else{
							for(string::iterator k=pairs.backward[id].begin();k!=pairs.backward[id].end();k++){
								if((*k)!='#'){
									fprintf(file,"%c",(*k));
								}else{
									break;
								}
							}
						}

						fprintf(file,"%c",'\t');


						if(pairs.matches[id].qualitvals.size()==0){
							fprintf(file,"%c",'*');
						}else{
							fprintf(file,"%s",pairs.matches[id].qualitvals.c_str());
						}

						if( pairs.matches[id].match[0].identity > parameters.identity_treshold && pairs.matches[id].match[0].score > parameters.score_treshold){

							fprintf(file,"%c",'\t');
							fprintf(file,"%s","AS:i:");
							if(flag){
								fprintf(file,"%i",(int)(*match_pair).score);
							}else{
								fprintf(file,"%c",'*');
							}

							fprintf(file,"%c",'\t');
							fprintf(file,"%s","MD:Z:");
							calcMD(file,(*match_pair));
						}

						fprintf(file,"%c",'\n');
					}
				}//end for
			}
		}
		id++;
		(*i).match.clear();
		(*i).read_name.clear();
		(*i).qualitvals.clear();
	}

	fclose(file);
	cout << "\t" << "aligned: " << allowed << " out of: " << reads.matches.size() << endl;

	if (pairs.forward.size()) {
		cout << "\t" << "paired aligned: " << paired_allowed << " out of: " << pairs.matches.size() << endl;
	}
	pairs.matches.clear();
	reads.matches.clear();
}
