/*
 * Match_Mismatch_CUDA_Kernel.cu
 *
 *  Created on: Nov 12, 2009
 *      Author: fritz
 */
#include "../CUDA_Kernel.cuh"

__device__ __constant__ float param2[4*sizeof(float)];

__global__ void  MatchMismatch_Cuda_Kernel(char * scaffold_gpu,char * reads_gpu,float * results_gpu){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

// ============= shared mem ============================

	extern __shared__ char smemf[];

//	unsigned int * readId =(int *)&smemf[0];
	unsigned int * run1 =   	(unsigned int *)&smemf[0];

	//================= starting calculation ================

	unsigned int readId=param2[0]*index;

	if(reads_gpu[readId]!=' '){

		run1[threadIdx.x]=readId+param2[0];
		float counter=0.0;
		while(readId<run1[threadIdx.x]){
			if(reads_gpu[readId] == scaffold_gpu[readId]){
				counter++;
			}
			readId++;
		}

		results_gpu[index] = counter;

	}else{
		results_gpu[index] =-1.0;
	}
}
__global__ void  MatchMismatchBS_Cuda_Kernel(char * scaffold_gpu,char * reads_gpu,float * results_gpu){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

// ============= shared mem ============================

	extern __shared__ char smemf[];

	int * readId =		(int *)&smemf[0];
	float * run1 =   	(float *)&smemf[sizeof(int)*256];


	//================= starting calculation ================
	readId[threadIdx.x]=param2[0]*index;
	if(reads_gpu[readId[threadIdx.x]]!=' '){
		float counter=0.0;
		for(run1[threadIdx.x]=0; run1[threadIdx.x]< param2[0];run1[threadIdx.x]++){
			if( reads_gpu[(int)(run1[threadIdx.x]+readId[threadIdx.x])]=='T' && scaffold_gpu[(int)run1[threadIdx.x]+readId[threadIdx.x]]=='T')
				counter+= param2[3] ; //T-T match
			else if(reads_gpu[(int)(run1[threadIdx.x]+readId[threadIdx.x])]== scaffold_gpu[(int)run1[threadIdx.x]+readId[threadIdx.x]]){
				counter+=param2[1]; //match
			}else if(reads_gpu[(int)(run1[threadIdx.x]+readId[threadIdx.x])]=='T' && scaffold_gpu[(int)run1[threadIdx.x]+readId[threadIdx.x]]=='C'){
				counter+= param2[4]; //T-C mismatch
			}else if (reads_gpu[(int)(run1[threadIdx.x]+readId[threadIdx.x])]!='N'){
				counter+=param2[2]; //mismatch
			}
		}
		results_gpu[index] = counter;
	}else{
		results_gpu[index] =-1.0;
	}
}

